﻿using System;
using Bend.Util;
using System.IO;

namespace PPTShow
{
    public class MyHttpServer : HttpServer
    {
        PowerpointController _document;

        public MyHttpServer(PowerpointController document, int port)
            : base(port)
        {
            _document = document;
        }

        public override void handleGETRequest(HttpProcessor p)
        {
            string urlText = p.http_url;

            int pos = urlText.IndexOf("?");
            if (pos != -1)
            {
                urlText = urlText.Substring(0, pos);
            }

            if (urlText.EndsWith("/test") == true)
            {
                p.writeSuccess("text/html");
                p.outputStream.Write(DateTime.Now + ": Hello World!");
            }
            else if (urlText.Contains("/startShow") == true)
            {
                _document.StartShow(1);
                p.writeSuccess("text/html");
                p.outputStream.Write("OK");
            }
            else if (urlText.EndsWith("/getSnapshot") == true)
            {
                p.writeSuccess("application/json");
                p.outputStream.Write(_document.DocumentAsText);
            }
            else if (urlText.Contains("/setSlide/") == true)
            {
                string txt = urlText.Substring(urlText.LastIndexOf('/') + 1);

                int slide;
                if (Int32.TryParse(txt, out slide) == true)
                {
                    _document.SetCurrentSlide(slide);
                }

                p.writeSuccess("text/html");
                p.outputStream.Write("OK");
            }
                /*
            else if (urlText.Contains("/startShow/") == true)
            {
                string txt = urlText.Substring(urlText.LastIndexOf('/') + 1);

                int slide;
                if (Int32.TryParse(txt, out slide) == true)
                {
                    _document.StartShow(slide);
                }

                p.writeSuccess("text/html");
                p.outputStream.Write("OK");
            }

            else if (urlText.Contains("/nextAnimation") == true)
            {
                _document.NextAnimation();
                p.writeSuccess("text/html");
                p.outputStream.Write("OK");
            }
                 */
        }

        public override void handlePOSTRequest(HttpProcessor p, StreamReader inputData)
        {
        }
    }
}
